# -*- encoding: utf-8 -*-
##############################################################################
#
#    Avanzosc - Avanced Open Source Consulting
#    Copyright (C) 2011 - 2012 Avanzosc <http://www.avanzosc.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

from osv import fields,osv
from tools.translate import _

class lines (osv.osv): 
    _name = 'lines'
    _description = 'Journey Lines'
    _columns = {
            'partner_id' : fields.many2one ('res.partner','Partner', size=34, required=True),
            'line_id' : fields.char ('Line Code',size=14, required=True),
            'name' : fields.char ('Description', size=34),
            'ref_line_id' : fields.one2many ('journey.headers', 'line_id', 'Journeys of the Line'),
        }

lines() 
    
class journey_headers (osv.osv): 
    _name = 'journey.headers'
    _description = 'Journey Headers'
    
    _columns = {
            'name': fields.char('Description', size=64, required=True,select=True),
            'line_id' : fields.many2one ('lines','Line Code'),
            'journey_header_id' : fields.char ('Journey Header Code',size=4, required=True),
            'pay_type' : fields.float('Pay type', size=24),
            'ref_journey_id' : fields.one2many ('journey.info', 'journey_id','Journey Info'),
        }
    
journey_headers()

class stop_places(osv.osv): 
    _name = 'stop.places'
    _description = 'Sttoping Places'
    
    _columns = {
            'stop_id' : fields.char ('Stop Place Code', size=10, required=True),
            'name': fields.char('Description', size=34, required=True,select=True),
            'type' : fields.char ('Stop Place Type', size=14),
            'position' : fields.char ('position', size=14),
            'template' : fields.boolean ('Template', size=4),
            'prime' : fields.boolean ('Prime', size=4),
            'location': fields.many2one('city.city', 'Location'),
            #'ref_stop_places' : fields.many2one ('journey.info', 'Journey Info'),
            #'ref_stop_places' : fields.many2many ('journey.info', 'journey_info_stop_places', 'stop_id', 'journey_id', 'Journey Info'),
            }
    
stop_places()

class journey_info (osv.osv): 
    _name = 'journey.info'
    _description = 'Journey Info'
    
    _columns = {
            'journey_id' : fields.many2one ('journey.headers', 'Journey'),
            'gap' : fields.integer ('Gap', size=34, required=True),
            'time' : fields.integer('Time', size=14, required=True),
            'distance' : fields.float('Distance', size=14, required=True),
            't_distance' : fields.float('Total Distance', size=14),
            'arrangement' : fields.integer ('Arrangement',size=14, required=True),
            'ref_journey_info' : fields.many2one ('stop.places', 'Stopping Places'),
            #'ref_journey_info' : fields.one2many ('stop.places', 'stop_id','Stopping Places'),
            #'ref_journey_info' : fields.many2many ('stop.places', 'journey_info_stop_places','journey_id','stop_id','Stopping Places'),
        }

journey_info() 


class prohibitions (osv.osv): 
    _name = 'prohibitions'
    _description = 'Prohibitions'
 
    _columns = {
            #'codemp' : fields.integer ('codemp', size=34, required=True),
            #'codlinea' : fields.integer ('Codigo Linea', size=34, required=True),
            'line_id' : fields.many2one ('lines','Line Code'),
            'stop_orig': fields.many2one ('stop.places','Stop Origin Code', size=34, required=True),
            'stop_dest': fields.many2one ('stop.places','Stop Destination Code', size=34, required=True),
            }

prohibitions()



class serviday (osv.osv): 
    _name = 'serviday'
    _description = 'Day Services'
 
    _columns = {
            #'codemp' : fields.integer ('codemp', size=34, required=True),
            'day_id' : fields.integer ('Day Code', size=34, required=True),
            'date' : fields.date ('Limit Date', size=34, required=True),
            'ref_service_id' : fields.one2many ('services', 'service_id', 'Services'),
            }
serviday ()

class servihol (osv.osv): 
    _name = 'servihol'
    _description = 'Holiday Services'
 
    _columns = {
            #'codemp' : fields.integer ('codemp', size=34, required=True),
			'hol_id' : fields.integer ('Holiday Code', size=14, required=True),
            'ref_service_id' : fields.one2many ('services', 'service_id', 'Services'),
            'date' : fields.date ('Limit Date', size=24, required=True),
            }
      
servihol()

class servitype(osv.osv): 
    _name = 'servitype'
    _description = 'Service Type'
 
    _columns = {
            #'codemp' : fields.integer ('codemp', size=34, required=True),
			'stype_id' : fields.integer ('Service Type', size=34, required=True),
            'name': fields.char('Description', size=64, required=True,select=True),
            'date' : fields.date ('Limit Date', size=34, required=True),
            'ref_service_id' : fields.one2many ('services', 'service_id', 'Services'),
            
            }
servitype()

class services (osv.osv): 
    _name = 'services'
    _description = 'Services'
 
    _columns = {
            #'codemp' : fields.integer ('codemp', size=34, required=True),
            'service_id' : fields.integer ('Service Code', size=34, required=True),
            'schedule' : fields.integer ('Schedule', size=34, required=True),
            'exp_num' : fields.integer ('Expedition Number', size=34),
            'journey_header_id': fields.many2one ('journey.headers', 'Journey Header Code'),
            'ref_journey_id' : fields.one2many ('journey.info', 'journey_id','Journey Info'),
            'ref_day_id' : fields.many2one ('serviday','Working Day Services'),
            'ref_hol_id' : fields.many2one ('servihol','Holyday Services'),
            'ref_dtype_id' : fields.many2one ('servitype','Type Services'),
            }
services ()

